local Zifnabs_release="r131021b"
local RESET_DATA=false
local uncompleted="START"

local Zifnabs = {}
_G.Zifnabs = Zifnabs

Zifnabs.plugins={
		[1]={["name"]="Zifnabs_Buffmon"},
		[2]={["name"]="Zifnabs_RP"},
		[3]={["name"]="Zifnabs_Hatelist"},
		}

local me=getglobal("Zifnabs_Main")
local control=getglobal("Zifnabs_Control")

local default_settings={
	["release"]="firstload",
	["anchor"]={["point"]="CENTER",["relativePoint"]="CENTER",["relativeTo"]="UIParent",["x"]=0,["y"]=0},
	["on"]=true,
	["visible"]=true,
	["reloadui"]=true,
	["hud"]={["time"]=7,["size"]=44,["startcolor"]={1,0.7,0},["endcolor"]={0,0,0.6},["x"]=0,["y"]=180},
	["timer"]={["active"]=true,["hud"]=true,["sound"]="remind.mp3"},
}
local settings={}
local variables_loaded=false
local hud_data={["time"]=0,["color"]={0,0,0},["flip"]=0}
local hud_frame=nil
local hud_info=nil

SLASH_Zifnabs1="/zi"
SlashCmdList["Zifnabs"]=function(editBox,command) Zifnabs:slash(command) end

local timer={["list"]={},["since_load"]=0,["last"]=0,["updates"]=0}
uncompleted=nil

-- ******************************************************************************************
-- * ON LOAD
-- ******************************************************************************************

function Zifnabs_OnLoad(this)
	uncompleted="OnLoad"
	local lang=string.sub(GetLanguage():upper(), 1,2)
	local langfile="Interface/AddOns/Zifnabs/lang/"..lang..".lua"
	local func, err=loadfile(langfile)
	if (err) then
		Zifnabs:echo("language "..lang.." not available, loading DE")
		langfile="Interface/AddOns/Zifnabs/lang/DE.lua"
	end
	dofile(langfile);
	this:RegisterEvent("SAVE_VARIABLES")
	this:RegisterEvent("VARIABLES_LOADED")

	SaveVariables("Zifnabs_Settings")  -- settings are saved to this table
	Zifnabs:timer("add",45,"echo",Zifnabs.LANG.TIMER1)
	for p=1,#Zifnabs.plugins,1 do
		uncompleted="OnLoad "..Zifnabs.plugins[p]["name"]
		Zifnabs:dofile(Zifnabs.plugins[p]["name"])
	end
	uncompleted=nil
end

-- ******************************************************************************************
-- * ON EVENT
-- ******************************************************************************************

function Zifnabs_OnEvent(this,event,arg1,arg2,arg3,arg4)
	uncompleted=event
	if event=="VARIABLES_LOADED" then
		Zifnabs:initialize()
		Zifnabs:dofile("Zifnabs_Config")
	elseif event=="SAVE_VARIABLES" then
		Zifnabs:terminate()
	elseif event=="ZIFNABS_SLASH" then
		Zifnabs:slash(arg1)
	else
		Zifnabs:error(Zifnabs.LANG.UNKNOWN_EVENT..event)
	end

	for p=1,#Zifnabs.plugins,1 do
		if Zifnabs.plugins[p]["module"] then
			uncompleted=event.." "..Zifnabs.plugins[p]["name"]
			Zifnabs.plugins[p]["module"]:OnEvent(event) 
		end
	end
	uncompleted=nil
end

-- ******************************************************************************************
-- * ON UPDATE / TIMER
-- ******************************************************************************************

function Zifnabs_OnUpdate(this,elapsed)
	if uncompleted then 
		Zifnabs:error("uncompleted chunk! "..uncompleted)
		uncompleted=nil
	end
	timer.since_load=timer.since_load+elapsed
	timer.updates=timer.updates+1
	if settings.on==true then
		local last=timer.since_load-timer.last
		for p=1,#Zifnabs.plugins,1 do
			if Zifnabs.plugins[p]["onupdate"]==true then
				Zifnabs.plugins[p]["module"]:OnUpdate(elapsed,last,timer.updates,timer.since_load)
			end
		end

		if last>=1 then
			timer.last=math.floor(timer.since_load)
			timer.updates=0
			if timer.list[1] then
				if timer.list[1]["time"]<=timer.since_load then
					if settings.timer.active==true then Zifnabs:execute(timer.list[1]["function"],timer.list[1]["parm"]) end
					table.remove(timer.list,1)
				end
			end
		end
		if hud_data.time>0 then
			hud_data.time=hud_data.time-elapsed
			if hud_data.time<=0 then
				hud_frame:Hide()
			elseif hud_data.time<=2.5 then
				local delta0=settings.hud.startcolor[1]-settings.hud.endcolor[1]
				local delta1=settings.hud.startcolor[2]-settings.hud.endcolor[2]
				local delta2=settings.hud.startcolor[3]-settings.hud.endcolor[3]
				hud_data.color[1]=hud_data.color[1]-delta0*elapsed/2.5
				hud_data.color[2]=hud_data.color[2]-delta1*elapsed/2.5
				hud_data.color[3]=hud_data.color[3]-delta2*elapsed/2.5
				hud_info:SetColor(hud_data.color[1],hud_data.color[2],hud_data.color[3])
			elseif hud_data.flip==1 then
				hud_info:SetColor(1,0,0)
			elseif hud_data.flip==0 then
				hud_info:SetColor(hud_data.color[1],hud_data.color[2],hud_data.color[3])
			end
			hud_data.flip=1-hud_data.flip
		end
	end

end

-- Execute-Methode für den Timer
function Zifnabs:execute(func,parm)
	if func=="echo" then Zifnabs:echo(parm)
	elseif func=="timer" then Zifnabs:hud(settings.timer,parm)
	else Zifnabs:error(Zifnabs.LANG.UNDEFINED_TIMER_FUNCTION..func)
	end
end

-- ******************************************************************************************
-- * INITIALIZE
-- ******************************************************************************************

function Zifnabs:initialize()
	hud_frame=getglobal("Zifnabs_HUD")
	hud_info=getglobal("Zifnabs_HUD_Info_Text")
	me=getglobal("Zifnabs_Main")
	control=getglobal("Zifnabs_Control")
	if Zifnabs_Settings~=nil then
		if Zifnabs_Settings.point~=nil then
			Zifnabs:echo(Zifnabs.LANG.NEW_VERSION)
			RESET_DATA=true
		end
	end
	if RESET_DATA==true then Zifnabs_Settings=nil end
	if Zifnabs_Settings then 
		settings=Zifnabs_Settings 
	else 
		Zifnabs:echo(Zifnabs.LANG.LOADING_DEFAULTS)
		settings=default_settings
		Zifnabs_Settings=settings
	end
	Zifnabs_Settings.release=Zifnabs_release
	Zifnabs:reload_settings()
	variables_loaded=true
	Zifnabs:echo(Zifnabs_release.." "..Zifnabs.LANG.LOADED)
end

function Zifnabs:terminate()
	local point, relativePoint, scripts, x, y = me:GetAnchor()
	settings.anchor.point=point
	settings.anchor.relativePoint=relativePoint
	settings.anchor.x=x
	settings.anchor.y=y
	Zifnabs_Settings=settings
end

-- ******************************************************************************************
-- * SLASH COMMANDS
-- ******************************************************************************************

function Zifnabs:slash(command)
	local cmd,parm=Zifnabs:parse(command)
	if cmd=="hide" then
		Zifnabs:echo(Zifnabs.LANG.MAIN_HIDDEN)
		settings.visible=false
		me:Hide()
	elseif cmd=="off" then
		settings.on=false
		control:Hide()
		Zifnabs:echo(Zifnabs.LANG.OFF)
	elseif cmd=="on" then
		settings.on=true
		control:Show()
		Zifnabs:echo(Zifnabs.LANG.ON)
	elseif cmd=="show" then
		settings.visible=true
		me:Show()
	elseif cmd=="timer" then
		local time,text=Zifnabs:parse(parm)
		Zifnabs:timer("add",time,"timer",text)
		Zifnabs:echo(Zifnabs.LANG.TIMER_SET)
	else
		local file="Interface/AddOns/Zifnabs/lua/"..cmd..".lua"
		local func, err=loadfile(file)
		if err then 
			if string.sub(err,1,11)=="cannot open" then Zifnabs:error(cmd..": "..Zifnabs.LANG.UNKNOWN_COMMAND) else Zifnabs:error(err)	end
		else 
			Zifnabs:echo("ok") 
		end
	end
end

-- ******************************************************************************************
-- * MESSAGES TO USER
-- ******************************************************************************************

function Zifnabs:error(text) Zifnabs:echo("|cffff0000"..text.."|r") end

function Zifnabs:echo(text)
	if text==nil then text="*nil*"
	elseif text==false then text="*false*"
	elseif text==true then text="*true*"
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cffe09000Zifnabs: |r"..text)
end

function Zifnabs:chat(text)
	if text then
		local channel="SAY"
		local choice=string.lower(string.sub(text,1,2))
		local valid={["/s"]="SAY",["/g"]="GUILD",["/p"]="PARTY",["/z"]="ZONE",["/w"]="WORLD",["/y"]="WORLD"}
		if valid[choice] then
			channel=valid[choice]
			text=string.sub(text,3)
		end
		if text~="" then SendChatMessage(text, channel, 0) end
	end
end

function Zifnabs:emote(action)
	Zifnabs:echo("no emote "..action.." yet")
end

function Zifnabs:hud(checktable,text)
	Zifnabs:echo("|cff00d0ff"..text.."|r")
	if checktable==nil then checktable=default_settings.timer end
	if checktable.sound~=nil then PlaySoundByPath("Interface/Addons/Zifnabs/media/"..checktable.sound) end
	if checktable.hud then
		hud_data.time=settings.hud.time
		hud_data.color=settings.hud.startcolor
		hud_info:SetText(text)
		hud_info:SetColor(hud_data.color[1],hud_data.color[2],hud_data.color[3])
		hud_frame:ClearAllAnchors()
		hud_frame:SetAnchor("CENTER","CENTER","UIParent",settings.hud.x,settings.hud.y)
		hud_frame:Show()
	end
end


-- ******************************************************************************************
-- * LOAD/SAVE SETTINGS
-- ******************************************************************************************
function Zifnabs:init_settings(default_settings)
	local out_settings={}
	for key,value in pairs(default_settings) do
		if Zifnabs_Settings[key]==nil then
			out_settings[key]=default_settings[key]
			Zifnabs:echo(Zifnabs.LANG.NEW_SETTING..key)
			Zifnabs_Settings[key]=default_settings[key]
		elseif type(default_settings[key])=="table" then
			out_settings[key]={}
			if Zifnabs_Settings[key]==nil then Zifnabs_settings[key]={} end
			for ikey,ivalue in pairs(default_settings[key]) do
				if Zifnabs_Settings[key][ikey]==nil then
					out_settings[key][ikey]=default_settings[key][ikey]
					Zifnabs:echo(Zifnabs.LANG.NEW_SETTING..key.."."..ikey)
					Zifnabs_Settings[key][ikey]=default_settings[key][ikey]
				else
					out_settings[key][ikey]=Zifnabs_Settings[key][ikey]
				end
			end
		else
			out_settings[key]=Zifnabs_Settings[key]
		end
	end
	return out_settings
end

function Zifnabs:save_settings(default_settings,settings)
	for key,value in pairs(default_settings) do
		Zifnabs_Settings[key]=settings[key]
	end
end

function Zifnabs:reload_settings()
	settings=Zifnabs:init_settings(default_settings)
	me:ClearAllAnchors()
	me:SetAnchor(settings.anchor.point, settings.anchor.relativePoint, settings.anchor.relativeTo, settings.anchor.x, settings.anchor.y)
	if settings.visible then me:Show() else	Zifnabs:slash("hide") end
	if settings.on then control:Show() else Zifnabs:slash("off") end
	local reloadui=getglobal("Zifnabs_Main_ReloadUI")
	if settings.reloadui then reloadui:Show() else reloadui:Hide() end
end

function Zifnabs:timer(func,time,xfunc,xparm)
	if func=="add" then
		local seconds=0
		for number in string.gmatch(time, "%d+") do
			seconds=60*seconds+number
		end
		time=math.floor(0.5+seconds+timer.since_load)
		local entry={["time"]=time,["function"]=xfunc,["parm"]=xparm}
		local insert=1
		for t=#timer.list,-1,1 do
			if timer.list[t]["time"]>time then insert=t end 
		end
		table.insert(timer.list,insert,entry)
	elseif func=="del" then 
		for t=1,#timer,1 do
			if timer.list[t]["time"]==time and timer.list[t]["function"]==xfunc and timer.list[t]["parm"]==xparm then table.remove(timer.list,t) end
		end
	else return timer.list,timer.since_load
	end
end

function Zifnabs:plugin(name,module,onupdate)
	plugin=1+#Zifnabs.plugins
	for p=1,#Zifnabs.plugins,1 do
		if Zifnabs.plugins[p]["name"]==name then plugin=p end
	end
	if Zifnabs.plugins[plugin]==nil then Zifnabs.plugins[plugin]={["name"]=name} end
	Zifnabs.plugins[plugin]["module"]=module
	Zifnabs.plugins[plugin]["onupdate"]=onupdate
	if variables_loaded and module then module:OnEent("VARIABLES_LOADED") end
end

-- ******************************************************************************************
-- * WTF
-- ******************************************************************************************
function Zifnabs:parse(text)
	local blank=string.find(text," ")
	local parm=""
	if blank then
		parm=string.sub(text,blank+1)
		text=string.lower(string.sub(text,1,blank-1))
	end
	return text,parm
end

function Zifnabs:dofile(file)
	local file="Interface/AddOns/Zifnabs/lua/"..file..".lua"
	local func, err=loadfile(file)
	if err then Zifnabs:error(err) else dofile(file)	end
end

function Zifnabs:parse_name(widget)
	local name=string.gsub(widget:GetName(),"_"," ")
	local part={}
	for word in string.gmatch(name, "%w+") do
		part[#part+1]=word
	end
	return string.lower(part[#part-1].."_"..part[#part]),name,part
end
