local Zifnabs_Hatelist = {}
_G.Zifnabs_Hatelist = Zifnabs_Hatelist

local default_settings={
	["hatelist"]={["active"]=true,["bars"]=5,["locate"]="top"},
}
local settings={}
local bar={}
local is_visible=false
local player_name=UnitName("player")

Zifnabs:plugin("Zifnabs_Hatelist",Zifnabs_Hatelist,false)
-- ******************************************************************************************
-- * ON EVENT
-- ******************************************************************************************
function Zifnabs_Hatelist:OnEvent(event) Zifnabs_Hatelist_OnEvent(getglobal("Zifnabs_Hate_Control"),event) end
function Zifnabs_Hatelist_OnEvent(this,event)
	if event=="VARIABLES_LOADED" then
		Zifnabs_Hatelist:reload_settings()
		Zifnabs:dofile("Zifnabs_Config_Hatelist")
		this:RegisterEvent("TARGET_HATE_LIST_UPDATED")
		this:RegisterEvent("UNIT_TARGET_CHANGED")
		this:RegisterEvent("COMBATMETER_DAMAGE")
		this:RegisterEvent("COMBATMETER_HEAL")
	elseif event=="SAVE_VARIABLES" then
		Zifnabs:save_settings(default_settings,settings)
	elseif settings.hatelist.active~=true then -- do nothing
	elseif event=="TARGET_HATE_LIST_UPDATED" then Zifnabs_Hatelist:update()
	elseif event=="UNIT_TARGET_CHANGED" then Zifnabs_Hatelist:update()
	elseif event=="COMBATMETER_DAMAGE" or event=="COMBATMETER_HEAL" then TargetHateListRequest()		
	end
end

function Zifnabs_Hatelist:update()
	local list = {}

	do u=1,99,1
		local name,hate,damage=GetTargetHateList(u)
		if name==nil then u=99
		else
			list[u]={["name"]=name,["hate"]=hate,["damage"]=damage}
			max_hate=math.max(max_hate,hate)
		end
	end
	
	-- don't display if player is the only aggressor and is not in party or if no hate generateded yet or target is dead
	if not UnitExists("target") or UnitIsDeadOrGhost("target") or not UnitCanAttack("player", "target") then list={} end
	if #list==1 then
		if list[1]["name"]==player_name and UnitExist("party1")==false then list={} end
	end
	Zifnabs_Hatelist:show(list)
end

function Zifnabs_Hatelist:reload_settings()
	settings=Zifnabs:init_settings(default_settings)
	local anchor={}
	if settings.hatelist.locate=="right" then anchor={["me"]="TOPLEFT",["main"]="TOPRIGHT",["frame"]="Zifnabs_Main"}
	elseif settings.hatelist.locate=="left" then anchor={["me"]="TOPRIGHT",["main"]="TOPLEFT",["frame"]="Zifnabs_Main"}
	elseif settings.hatelist.locate=="bottom" then anchor={["me"]="TOPLEFT",["main"]="BOTTOMLEFT",["frame"]="Zifnabs_RolePlay"}
	else anchor={["me"]="BOTTOMLEFT",["main"]="TOPLEFT",["frame"]="Zifnabs_Main"}
	end
	local me=getglobal("Zifnabs_Hate")
	me:ClearAllAnchors()
	me:SetAnchor(anchor.me,anchor.main,anchor.frame,0,0)
	for r=1,5,1 do
		local row=getglobal("Zifnabs_Hate_Row_"..r)
		local name=getglobal("Zifnabs_Hate_Row_"..r.."_Text_Name")
		local value=getglobal("Zifnabs_Hate_Row_"..r.."_Text_Value")
		bar[r]={["row"]=row,["name"]=name,["value"]=value}
		local y=2+(r-1)*row:GetHeight()
		row:ClearAllAnchors()
		row:SetAnchor("TOPLEFT","TOPLEFT","Zifnabs_Hate",2,y)
		name:SetText("n"..r)
		value:SetText("v"..r)
	end
	me:Hide()
	is_visible=false
	local control=getglobal("Zifnabs_Hate_Control")
end

function Zifnabs_Hatelist:show(list)
	if #list==0 then 
		getglobal("Zifnabs_Hate"):Hide()
		is_visible=false
	else
		if is_visible==false then
			getglobal("Zifnabs_Hate"):Show()
			is_visible=true
		end
		local bars=math.min(5,math.min(#list,settings.hatelist.bars))
		getglobal("Zifnabs_Hate"):SetHeight(12*bars+4)
		for r=1,5,1 do
			if r>bars then bar[r]["row"]:Hide()
			else
				bar[r]["row"]:Show()
				if list[r]["name"]==player_name then bar[r]["row"]:SetBarColor(1.0,0.6,0.6) else bar[r]["row"]:SetBarColor(0.2,0.2,0.8) end
				bar[r]["row"]:SetValue(100*list[r]["hate"]/list[1]["hate"])
				bar[r]["name"]:SetText(list[r]["name"])
				local value=list[r]["hate"]
				if list[1]["hate"]>10000000 then value=math.floor(0.5+value/1000000).."M"
				elseif list[1]["hate"]>10000 then value=math.floor(0.5+value/1000).."K"
				end
				bar[r]["value"]:SetText(value)
			end
		end
	end
end
